/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.0
 *
 * @date        2025-05-31
 *
 * @attention
 *
 *  Copyright (C) 2023-2025 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (GEEHY SOFTWARE PACKAGE LICENSE).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the GEEHY SOFTWARE PACKAGE LICENSE for the governing permissions
 *  and limitations under the License.
 */

/* Includes */
#include "main.h"

/** @addtogroup Examples
  @{
*/

/** @addtogroup ADC_DiffMode
  @{
*/

/** @defgroup ADC_DiffMode_Macros Macros
  @{
*/

#define DEBUG_USART         USART1

/**@} end of group ADC_DiffMode_Macros */

/** @defgroup ADC_DiffMode_Functions Functions
  @{
*/

void ADC_Init(void);
/* USART Init */
void USART_Init(void);

/* Measure 3.3v using coefficient 3300, measure 5.0v using coefficient 5000 */
//static uint16_t s_measure_coefficient = 3300;
static uint16_t s_measure_coefficient = 5000;

/*!
 * @brief       Main program
 *
 * @param       None
 *
 * @retval      None
 */
int main(void)
{
    uint16_t diff = 0;
    int32_t ndiff = 0;

    APM_MINI_LEDInit(LED2);
    APM_MINI_LEDOff(LED2);

    APM_DelayInit(APM_DELAY_MS);

    USART_Init();
    ADC_Init();

    while (1)
    {
        while(ADC_ReadStatusFlag(ADC_FLAG_CC) == RESET);
        diff = ADC_ReadData();
        ndiff = ((2 * diff - 4095) * s_measure_coefficient) /4095;
        printf("diff = %d\r\n", ndiff);
        ADC_ClearStatusFlag(ADC_FLAG_CC);
        APM_MINI_LEDToggle(LED2);
        APM_Delay(500);
    }
}

/*!
 * @brief       USART Init
 *
 * @param       None
 *
 * @retval      None
 */
void USART_Init(void)
{
    USART_Config_T usartConfig;

    usartConfig.baudRate = 9600;                /*!< BaudRate is 9600 */
    usartConfig.wordLength = USART_WORD_LEN_8B; /*!< Word length is 8bit */
    usartConfig.stopBits = USART_STOP_BIT_1;    /*!< One stop bit */
    usartConfig.parity = USART_PARITY_NONE;     /*!< Parity disable */
    usartConfig.interrupt = USART_INT_NONE;     /*!< No interrupt */
    usartConfig.mode = USART_MODE_TX_RX;        /*!< Enable receive and transmit */
    /*  DEBUG_USART configuration */
    USART_Config(DEBUG_USART, &usartConfig);

    /*  Enable DEBUG_USART */
    USART_Enable(DEBUG_USART);
}

void ADC_Init(void)
{
    GPIO_Config_T gpioConfig;
    gpioConfig.mode = GPIO_MODE_IN_FLOATING;
    gpioConfig.speed = GPIO_SPEED_10MHz;
    gpioConfig.intEn = GPIO_EINT_DISABLE;
    gpioConfig.pin = GPIO_PIN_5;
    GPIO_Config(GPIOC, &gpioConfig);

    gpioConfig.pin = GPIO_PIN_6;
    GPIO_Config(GPIOC, &gpioConfig);

    ADC_Config_T adcConfig;
    ADC_ConfigStructInit(&adcConfig);
    ADC_Config(&adcConfig);
    ADC_ConfigConversionMode(ADC_CONV_MODE_CONTINUOUS);

    ADC_SetMode(ADC_MODE_DIFF_INPUT);
    ADC_SetDiffInputChannel(ADC_DIFF_CHANNEL_VAIN0);

    ADC_Enable();
    ADC_StartConversion();
}

#if defined (__CC_ARM) || defined (__ICCARM__) || (defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050))

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @param       *f:  pointer to a FILE that can recording all information
*              needed to control a stream
*
* @retval      The characters that need to be send.
*/
int fputc(int ch, FILE* f)
{
    /* send a byte of data to the serial port */
    USART_TxData8(DEBUG_USART, (uint8_t)ch);

    /* wait for the data to be send */
    while (USART_ReadStatusFlag(DEBUG_USART, USART_FLAG_TXBE) == RESET);

    return (ch);
}

#elif defined (__GNUC__)

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @retval      The characters that need to be send.
*/
int __io_putchar(int ch)
{
    /* send a byte of data to the serial port */
    USART_TxData8(DEBUG_USART, ch);

    /* wait for the data to be send  */
    while (USART_ReadStatusFlag(DEBUG_USART, USART_FLAG_TXBE) == RESET);

    return ch;
}

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       file:  Meaningless in this function.
*
* @param       *ptr:  Buffer pointer for data to be sent.
*
* @param       len:  Length of data to be sent.
*
* @retval      The characters that need to be send.
*/
int _write(int file, char *ptr, int len)
{
    int i;
    for (i = 0; i < len; i++)
    {
        __io_putchar(*ptr++);
    }

    return len;
}

#else
  #warning Not supported compiler type
#endif

/**@} end of group ADC_DiffMode_Functions */
/**@} end of group ADC_DiffMode */
/**@} end of group Examples */
